C----------------------------------------------------------------------
C     Redoing the local bifurcation of the model analysed by
C     Martin Boer, ch. 4 of thesis.
C---------------------------------------------------------------------- 
C
      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
C     ---------- ---- 
C     
      IMPLICIT DOUBLE PRECISION (A-Z) 
      INTEGER NDIM
      DIMENSION U(NDIM),PAR(*),F(NDIM)
      DOUBLE PRECISION x_1,x_2,x_3
      DOUBLE PRECISION a_1,a_2,b_1,b_2
      DOUBLE PRECISION d_1,d_2
      DOUBLE PRECISION T,mu
      DOUBLE PRECISION f_1,f_2
C     Declaring variables
      x_1=U(1)
      x_2=U(2)
      x_3=U(3)
C     Parameter values
      d_1=PAR(1)
      d_2=PAR(2)
C
      a_1 = 5.
      a_2 = 0.1
      b_1 = 3.
      b_2 = 2.
      f_1=(a_1*x_1)/(1. + b_1*x_1)
      f_2=(a_2*x_2)/(1. + b_2*x_2)
C     Formulas
      F(1)= x_1*(1. - x_1) - f_1*x_2
      F(2)= f_1*x_2 - d_1*x_2 - f_2*x_3
      F(3)= f_2*x_3 - d_2*x_3
C     
      RETURN 
      END 
C
      SUBROUTINE STPNT(NDIM,U,PAR) 
C     
      IMPLICIT DOUBLE PRECISION (A-Z) 
      INTEGER NDIM
      DIMENSION U(NDIM),PAR(*)
C
      PAR(1)=0.25               ! d1
      PAR(2)=0.015             ! d2
C
      U(1) = 6.28802E-01   
      U(2) = 2.14286E-01   
      U(3) = 1.19892E+01
C
      PAR(1) = 0.316552
      PAR(2) = 0.01
C
      xi1 = 0.8192459912
      xi2 = 0.125
      xi3 = 10.85129971
C
      v1 = -0.0988879493
      v2 = -0.1467798806
      v3 = -0.002393768847
C
      eps = 0.0001
      c1 = 1.
C      c2 = DSQRT(1. - c1**2)
      c2 = 0.
C
      U(1) = xi1 + eps*(c1*v2)
      U(2) = xi2 + eps*(c1*(-v1) + c2*v3)
      U(3) = xi3 + eps*(c2*(-v2))
C
      RETURN 
      END 
C     
      SUBROUTINE BCND 
      RETURN 
      END 
C     
      SUBROUTINE ICND 
      RETURN 
      END 
C     
      SUBROUTINE FOPT 
      RETURN 
      END 
C     
      SUBROUTINE PVLS(NDIM,U,PAR)
C     ---------- ----
C     
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER NDIM
      DIMENSION U(NDIM),PAR(*)
C     
C     Set PAR(3) equal to the minimum of U(1) = P
      PAR(3)=GETP('MIN',1,U)
      PAR(4)=GETP('MIN',2,U)
      PAR(5)=GETP('MIN',3,U)
C
C
      xi1 = 0.8192459912
      xi2 = 0.125
      xi3 = 10.85129971
C
      v1 = -0.0988879493
      v2 = -0.1467798806
      v3 = -0.002393768847
C
      eps = 0.01
C
      PAR(6) = U(1) - (xi1 - eps*v1)
      PAR(7) = U(2) - (xi2 - eps*v2)
      PAR(8) = U(3) - (xi3 - eps*v3)
C
      RETURN 
      END







































































































