C----------------------------------------------------------------------
C     Homoclinic P2P connection (Shil'nikov)
C---------------------------------------------------------------------- 
C
      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
C     ---------- ---- 
C
      IMPLICIT DOUBLE PRECISION (A-Z) 
      INTEGER NDIM
      DIMENSION U(NDIM),PAR(*),F(NDIM)
      DOUBLE PRECISION x_1,x_2,x_3
      DOUBLE PRECISION a_1,a_2,b_1,b_2
      DOUBLE PRECISION d_1,d_2
      DOUBLE PRECISION T,mu
      DOUBLE PRECISION f_1,f_2
C     Declaring variables
      x_1=U(1)
      x_2=U(2)
      x_3=U(3)
C     Parameter values
      d_1=PAR(1)
      d_2=PAR(2)
C
      a_1 = 5.
      a_2 = 0.1
      b_1 = 3.
      b_2 = 2.
      f_1=(a_1*x_1)/(1. + b_1*x_1)
      f_2=(a_2*x_2)/(1. + b_2*x_2)
C     Formulas
      F(1)= x_1*(1. - x_1) - f_1*x_2
      F(2)= f_1*x_2 - d_1*x_2 - f_2*x_3
      F(3)= f_2*x_3 - d_2*x_3
C     Rescaling
      F(1) = PAR(11)*F(1)
      F(2) = PAR(11)*F(2)
      F(3) = PAR(11)*F(3)
C
      RETURN 
      END 
C
      SUBROUTINE STPNT(NDIM,U,PAR) 
C     
      IMPLICIT DOUBLE PRECISION (A-Z) 
      INTEGER NDIM
      DIMENSION U(NDIM),PAR(*)
C
      PAR(1) = 0.316552         ! d1
      PAR(2) = 0.01             ! d2
C
      PAR(13) = 0.8192459912
      PAR(14) = 0.125
      PAR(15) = 10.85129971
C     Connection time
      PAR(11) = 2.5959162107E+02
C     Adjoint eigenvector
      v1 = -0.0988879493
      v2 = -0.1467798806
      v3 = -0.002393768847
C
      normv=SQRT(v1**2+v2**2+v3**2)
C      normw=SQRT(w1**2+w2**2+w3**2)
      v1 = v1/normv
      v2 = v2/normv
      v3 = v3/normv
C      w1 = w1/normw
C      w2 = w2/normw
C      w3 = w3/normw
C     Eigenvector (stable)
      PAR(16) = v1
      PAR(17) = v2
      PAR(18) = v3
C     Eigenvalue
      PAR(19) = -0.6131748298
C
C      eps = PAR(3) stable side
C      epsilon=PAR(4) adjoint stable side
C      c1=PAR(5)
C      c2=PAR(6)
      PAR(3) = 0.01
      PAR(4) = 0.0001
      PAR(5) = 1.
C      PAR(6) = DSQRT(1. - PAR(5)**2)
      PAR(6) = 0.
C
      PAR(24) = 3.6243641421E-10  
      PAR(25) = -6.8003469090E-02  
      PAR(26) = -2.2947790142E+00
C
      PAR(27) = 0.01            ! onzingetal
C
      RETURN 
      END 
C     
      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
C     ---------- ---- 
C 
      IMPLICIT DOUBLE PRECISION (A-Z) 
      INTEGER NDIM,NBC
      DIMENSION PAR(*),ICP(*),U0(NDIM),U1(NDIM),FB(NBC)
      DIMENSION A(3,3)
C
      a_1 = 5.
      a_2 = 0.1
      b_1 = 3.
      b_2 = 2.
C
      d_1 = PAR(1)
      d_2 = PAR(2)
C
      x1 = PAR(13)   
      x2 = PAR(14)   
      x3 = PAR(15)
C
      v1 = PAR(16)
      v2 = PAR(17)
      v3 = PAR(18)
C     
      lambda = PAR(19)
C     Functional responses
      f_1=(a_1*x1)/(1. + b_1*x1)
      f_2=(a_2*x2)/(1. + b_2*x2)
C
      e1 = a_1*x2/(1 + b_1*x1)
      e2 = a_1*x1*x2*b_1/((1 + b_1*x1)*(1 + b_1*x1))
      e3 = a_1*x1/(1 + b_1*x1)
      e4 = a_2*x3/(1 + b_2*x2)
      e5 = a_2*x2*x3*b_2/((1 + b_2*x2)*(1 + b_2*x2))
      e6 = a_2*x2/(1 + b_2*x2)
C     Jacobian elements
      A(1,1) = 1 - 2*x1 - e1 + e2
      A(1,2) = - e3
      A(1,3) = 0.0
C
      A(2,1) = e1 - e2
      A(2,2) = e3 - d_1 - e4 + e5
      A(2,3) = - e6
C
      A(3,1) = 0.0
      A(3,2) = e4 - e5
      A(3,3) = e6 - d_2
C
C      print*,A(1,1),A(1,2),A(1,3)
C      print*,A(2,1),A(2,2),A(2,3)
C      print*,A(3,1),A(3,2),A(3,3)
C      print*,'  '
C     Equations
      FB(1)= x1*(1. - x1) - f_1*x2
      FB(2)= f_1*x2 - d_1*x2 - f_2*x3
      FB(3)= f_2*x3 - d_2*x3
C     Eigenfunction normalisation
      FB(4) = v1*v1 + v2*v2 + v3*v3 - 1.0
C     Stable vector (v1,v2,v3)^T
C      FB(5) = A(1,1)*v1 + A(1,2)*v2 + A(1,3)*v3 - lambda*v1
C      FB(6) = A(2,1)*v1 + A(2,2)*v2 + A(2,3)*v3 - lambda*v2
C      FB(7) = A(3,1)*v1 + A(3,2)*v2 + A(3,3)*v3 - lambda*v3
C
      FB(5) = A(1,1)*v1 + A(2,1)*v2 + A(3,1)*v3 - lambda*v1
      FB(6) = A(1,2)*v1 + A(2,2)*v2 + A(3,2)*v3 - lambda*v2
      FB(7) = A(1,3)*v1 + A(2,3)*v2 + A(3,3)*v3 - lambda*v3
C     Eqn. (25a)   Adjoint side
      epsilon=PAR(4) 
C
      c1=PAR(5)
      c2=PAR(6)  
C
      FB(8) = U0(1) - x1 - epsilon*c1*v2
      FB(9) = U0(2) - x2 + epsilon*c1*v1 - epsilon*c2*v3
      FB(10) = U0(3) - x3 + epsilon*c2*v2
C
      ff1=(a_1*U0(1))/(1. + b_1*U0(1))
      ff2=(a_2*U0(2))/(1. + b_2*U0(2))
C     Formulas
      g1 = U0(1)*(1. - U0(1)) - ff1*U0(2)
      g2 = ff1*U0(2) - d_1*U0(2) - ff2*U0(3)
      g3 = ff2*U0(3) - d_2*U0(3)
C
      h1 = (U0(1) - x1)
      h2 = (U0(2) - x2)
      h3 = (U0(3) - x3)
C
C     Eq. (22h)
      FB(11) = h1*g1 + h2*g2 + h3*g3 - PAR(27)
C      print*,FB(11)
C
      eps = PAR(3)
C     Non-adjoint side
      FB(12) = U1(1) - (x1 - eps*v1) - PAR(24)
      FB(13) = U1(2) - (x2 - eps*v2) - PAR(25)
      FB(14) = U1(3) - (x3 - eps*v3) - PAR(26)
C
      FB(15) = c1**2 + c2**2 - 1.
C
C      FB(19) = (U0(3) - x3) - PAR(28)
C
C      print*,FB(12)
C      print*,FB(13)
C      print*,FB(14)
C      print*,FB(18)
C
      RETURN 
      END 
C     
      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT) 
C     ---------- ---- 
C 
      IMPLICIT DOUBLE PRECISION (A-Z) 
      INTEGER NDIM,NINT
      DIMENSION U(NDIM),UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM) 
      DIMENSION FI(NINT),DINT(NINT,*),ICP(*),PAR(*) 
C
C     Integral phase condition 
C     ------------------------
      FI(1)=UPOLD(1)*(U(1)-UOLD(1)) + UPOLD(2)*(U(2)-UOLD(2))
     *  + UPOLD(3)*(U(3)-UOLD(3))
C
      RETURN 
      END 
C     
      SUBROUTINE FOPT 
      RETURN 
      END 
C     
      SUBROUTINE PVLS(NDIM,U,PAR)
C     ---------- ----
C     
      IMPLICIT DOUBLE PRECISION (A-Z)
      INTEGER NDIM
      DIMENSION U(NDIM),PAR(*)
C     
      RETURN 
      END







































































































